#!/usr/bin/python

##################
# dsviewer_seq.py
#
# Copyright David Baddeley, 2009
# d.baddeley@auckland.ac.nz
#
# This file may NOT be distributed without express permision from David Baddeley
#
##################

#!/usr/bin/env python
# generated by wxGlade 0.3.3 on Mon Jun 14 06:48:07 2004

import wx
import sys
import os
sys.path.append(".")

#import viewpanel
import cSMI as example
import dCrop
import logparser
import read_kdf
import scipy

from myviewpanel import MyViewPanel

class DSViewFrame(wx.Frame):
    def __init__(self, parent=None, title='', log = None,filenames = None,pos=0, bg=None):
        wx.Frame.__init__(self,parent, -1, title)

        #self.ds = dstack
        self.log = log

        self.saved = True
        self.numAvg = 0
        self.bgSub = False
        self.bg = bg

        #if (dstack == None):
        #    if (filename == None):
        #        fdialog = wx.FileDialog(None, 'Please select Data Stack to open ...',
        #            wildcard='*.kdf', style=wx.OPEN|wx.HIDE_READONLY)
        #        succ = fdialog.ShowModal()
        #        if (succ == wx.ID_OK):
        #            self.ds = example.CDataStack(fdialog.GetPath().encode())
        #            self.SetTitle(fdialog.GetFilename())
        #            self.saved = True
        #            #fn =
        #    else:
        #        self.ds = example.CDataStack(filename)
        #        #self.SetTitle(title)
        #        self.saved = True

        self.filenames = filenames
        self.pos = pos

        self.ds = example.CDataStack(filenames[pos])

        self.vp = MyViewPanel(self, self.ds)
        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(self.vp, 1,wx.EXPAND,0)
        self.SetAutoLayout(1)
        self.SetSizer(sizer)
        sizer.Fit(self)
        #sizer.SetSizeHints(self)

        # Menu Bar
        self.menubar = wx.MenuBar()
        self.SetMenuBar(self.menubar)
        tmp_menu = wx.Menu()
        #F_SAVE = wx.NewId()
        #F_CLOSE = wx.NewId()
        tmp_menu.Append(wx.ID_SAVEAS, "Save As", "", wx.ITEM_NORMAL)
        tmp_menu.Append(wx.ID_CLOSE, "Close", "", wx.ITEM_NORMAL)
        self.menubar.Append(tmp_menu, "File")

        mEdit = wx.Menu()
        EDIT_CLEAR_SEL = wx.NewId()
        EDIT_CROP = wx.NewId()
        mEdit.Append(EDIT_CLEAR_SEL, "Reset Selection", "", wx.ITEM_NORMAL)
        mEdit.Append(EDIT_CROP, "Crop", "", wx.ITEM_NORMAL)
        self.menubar.Append(mEdit, "Edit")

        # Menu Bar end
        wx.EVT_MENU(self, wx.ID_SAVEAS, self.saveStack)
        wx.EVT_MENU(self, wx.ID_CLOSE, self.menuClose)
        wx.EVT_MENU(self, EDIT_CLEAR_SEL, self.clearSel)
        wx.EVT_MENU(self, EDIT_CROP, self.crop)
        wx.EVT_CLOSE(self, self.OnCloseWindow)

        wx.EVT_KEY_DOWN(self.vp.imagepanel, self.OnKeyPress)
		
        self.statusbar = self.CreateStatusBar(1, wx.STB_SIZEGRIP)

        self.Layout()
        self.update()

    def update(self):
        self.vp.imagepanel.Refresh()
        self.statusbar.SetStatusText('Slice No: (%d/%d) \tAveraging: %d' % (self.pos, len(self.filenames), self.numAvg))

    def saveStack(self, event=None):
        fdialog = wx.FileDialog(None, 'Save Data Stack as ...',
            wildcard='*.kdf', style=wx.FD_SAVE|wx.HIDE_READONLY)
        succ = fdialog.ShowModal()
        if (succ == wx.ID_OK):
            self.ds.SaveToFile(fdialog.GetPath())
            if not (self.log is None):
                lw = logparser.logwriter()
                s = lw.write(self.log)
                log_f = open('%s.log' % fdialog.GetPath().split('.')[0], 'w')
                log_f.write(s)
                log_f.close()
                
            self.SetTitle(fdialog.GetFilename())
            self.saved = True

    def menuClose(self, event):
        self.Close()

    def OnCloseWindow(self, event):
        if (not self.saved):
            dialog = wx.MessageDialog(self, "Save data stack?", "pySMI", wx.YES_NO|wx.CANCEL)
            ans = dialog.ShowModal()
            if(ans == wx.ID_YES):
                self.saveStack()
                self.Destroy()
            elif (ans == wx.ID_NO):
                self.Destroy()
            else: #wxID_CANCEL:   
                if (not event.CanVeto()): 
                    self.Destroy()
                else:
                    event.Veto()
        else:
            self.Destroy()
			
    def clearSel(self, event):
        self.vp.ResetSelection()
        self.vp.Refresh()
        
    def crop(self, event):
        cd = dCrop.dCrop(self, self.vp)
        if cd.ShowModal():
            ds2 = example.CDataStack(self.ds, cd.x1, cd.y1, cd.z1, cd.x2, cd.y2, cd.z2, cd.chs)
            dvf = DSViewFrame(self.GetParent(), '--cropped--', ds2)
            dvf.Show()

    def ChangePos(self, newpos):
        if newpos >= 0 and newpos < (len(self.filenames)-self.numAvg):
            self.pos = newpos
            self.ds = example.CDataStack(self.filenames[self.pos])
            dsa = example.CDataStack_AsArray(self.ds,0)
            if self.numAvg > 0:
                for i in range(self.numAvg):
                    dsa += example.CDataStack_AsArray(example.CDataStack(self.filenames[self.pos + i + 1]),0)
                    dsa -= dsa.min()
            
            if (not self.bg is None) and self.bgSub:
                print((dsa.shape))
                print((self.bg.shape))
                if self.numAvg == 0:
                    dsa -= self.bg
                else:
                    dsa -= scipy.minimum(dsa,(self.bg - self.bg.min())*(self.numAvg + 1.0))
            
            self.vp.ds = self.ds
            self.update()
        else:
            raise RuntimeError('invalid position')

    def OnKeyPress(self, event):
        #print 'hi'
        if event.GetKeyCode() == 80:
            self.ChangePos(self.pos - 1)
        elif event.GetKeyCode() == 78:
            self.ChangePos(self.pos + 1)
        elif event.GetKeyCode() == 91:
            if not self.numAvg == 0:
                self.numAvg -=1
                self.ChangePos(self.pos)
            #print self.numAvg
        elif event.GetKeyCode() == 93:
            self.numAvg +=1
            self.ChangePos(self.pos)
            #print self.numAvg
        elif event.GetKeyCode() == 66:
            self.bgSub = not self.bgSub
            self.ChangePos(self.pos)
        else:
            event.Skip()



class MyApp(wx.App):
    def OnInit(self):
        #wx.InitAllImageHandlers()
        print((sys.argv))
        bg = None
        if (len(sys.argv) > 1):
            fnms = os.listdir(sys.argv[1])
        else:
            raise RuntimeError('Must provide list of files on command line')

        if (len(sys.argv) == 3):
            bg = read_kdf.ReadKdfData(sys.argv[2])[:,:,:,0]

        fnames = []
        for fn in fnms:
            fnames.append(sys.argv[1] + fn)
        vframe = DSViewFrame(None,  filenames=fnames, bg=bg)

        self.SetTopWindow(vframe)
        vframe.Show(1)
        return 1

# end of class MyApp

if __name__ == "__main__":
    app = MyApp(0)
    app.MainLoop()
